export declare function createSignal<T>(value?: T, comparator?: (v?: T, p?: T) => boolean): [() => T, (v: T) => void];
export declare function createEffect<T>(fn: (v?: T) => T, seed?: T): void;
export declare function createDependentEffect<T>(fn: (v?: T) => T, deps: () => any | (() => any)[], defer?: boolean): void;
export declare function createMemo<T>(fn: (v: T | undefined) => T, value?: T): () => T;
export declare function createRoot<T>(fn: (dispose: () => void) => T, detachedOwner?: ComputationNode): T;
export declare function freeze<T>(fn: () => T): T;
export declare function sample<T>(fn: () => T): T;
export declare function onCleanup(fn: (final: boolean) => void): void;
export declare function isListening(): boolean;
export interface Context {
    id: symbol;
    initFn?: Function;
}
export declare function createContext(initFn?: Function): Context;
export declare function useContext(context: Context): any;
export declare function getContextOwner(): ComputationNode | null;
export declare function setContext(key: symbol | string, value: any): void;
export declare class DataNode {
    value: any;
    pending: any;
    log: Log | null;
    constructor(value: any);
    current(): any;
    next(value: any): any;
}
declare class ComputationNode {
    fn: ((v: any) => any) | null;
    value: any;
    age: number;
    state: number;
    source1: null | Log;
    source1slot: number;
    sources: null | Log[];
    sourceslots: null | number[];
    log: Log | null;
    owner: any;
    context: any;
    noRecycle?: boolean;
    owned: ComputationNode[] | null;
    cleanups: (((final: boolean) => void)[]) | null;
    constructor();
    current(): any;
}
declare type Log = {
    node1: null | ComputationNode;
    node1slot: number;
    nodes: null | ComputationNode[];
    nodeslots: null | number[];
};
export {};
